#ifndef _CRAND_H
#define _CRAND_H

#include <common.h>

#define JR_MAX (UINT64_MAX >> 16)

#ifdef __cplusplus
extern "C" {
#endif

struct jr_state;

//TODO: make all these functions visibility("internal")

void _jr_seed(struct jr_state* restrict state, unsigned long with);
long _jr_proc(struct jr_state* restrict state);
struct jr_state* _jr_alloc();
void _jr_free(struct jr_state* restrict state);

struct jr_state* _jr_new(unsigned long with);

#ifdef __cplusplus
}
#endif

#endif
